<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * administrator/components/com_jmylife/controllers/configuration.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */
// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
// imports
jimport( 'joomla.application.component.controller' );
jimport('joomla.filesystem.file');

/**
 * JMyLife Component Configuration Controller
 *
 * @package    JMyLife
 * @subpackage Components
 */
class JmylifeControllerConfiguration extends JController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct( $default=array() )
	{
		parent::__construct( $default );
	}

	/**
	 * Method to display the view
	 *
	 * @access    public
	 */
	function display()
	{
		parent::display();
	}
	function reload()
	{
		$appl =& JFactory::getApplication();
		$appl->redirect('index.php?option=com_jmylife&view=configuration');
	}

	function save()
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		// build query
		$query = 'SELECT '
		       . '* '
		       . 'FROM `#__jmylife_configuration` '
		       ;
		$_JMLConfig->db->setQuery( $query );
		// get configs
		$configs = $_JMLConfig->db->loadObjectList();
		// what's changed
		foreach( $configs as $config )
		{
			$key = $config->key;
			$value = $config->value;
			// what function do we parse with?
			switch( $config->type )
			{
				case 'radio':
				case 'int':
					$newval = JRequest::getInt( $key );
					$dbquot = false;
					break;
				case 'usergroup':
				case 'menuitem':
					$newval = (int)$_REQUEST[$key][0];
					$dbquot = false;
					break;
				case 'editor':
					$newval = JRequest::getVar( $key, '', 'post', 'string', JREQUEST_ALLOWRAW );
					break;
				case 'color':
				case 'text':
				case 'textarea':
				default:
					$newval = JRequest::getString( $key );
					$dbquot = true;
					break;
			}
			// check if it's in request & changed, then push
			if( $newval !== $val )
			{
				$table = $_JMLConfig->isLang( $key ) ? 'language' : 'configuration';
				$query = 'UPDATE `#__jmylife_'.$table.'` SET `value`='
				       . ( $dbquot ? $_JMLConfig->db->quote( $newval ) : ''.$newval.'' )
				       . ' WHERE `key` = "'.$key.'"'
				       ;
				$_JMLConfig->db->setQuery( $query );
				$_JMLConfig->db->query();
			}
		}
		// lower case for 1.6
		$appl->enqueuemessage(JText::_('COM_JMYLIFE_CONFIGURATION_SAVED'));
		$appl->redirect( 'index.php?option=com_jmylife&view=configuration' );
	}
}