<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * administrator/components/com_jmylife/models/categories.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Categories Model
 *
 * @package    JMyLife
 * @subpackage Components
 */
class JmylifeModelCategories extends JModel
{
	/**
	 * data
	 * @var stdClass
	 */
	var $_data = null;

	/**
	 * Items total - for pagination
	 * @var integer
	 */
	var $_total = null;

	/**
	 * Pagination object
	 * @var object
	 */
	var $_pagination = null;

	/**
	 * category list
	 * @var array
	 */
	var $_categories = null;

	/**
	 * contructor
	 */
	function __construct()
	{
		parent::__construct();
		$option = JRequest::getCmd('option');
		$view = JRequest::getWord('view');
		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();

		// Get pagination request variables
		$limit = $appl->getUserStateFromRequest( 'global.list.limit', 'limit', $appl->getCfg( 'list_limit' ), 'int' );
		$limitstart = JRequest::getVar( 'limitstart', 0, '', 'int' );
		// In case limit has been changed, adjust it
		$limitstart = ( $limit != 0 ? ( floor( $limitstart / $limit ) * $limit ) : 0 );
		// set in state
		$this->setState( 'limit', $limit );
		$this->setState( 'limitstart', $limitstart );

		// a little cleanup
		$filter_view       = $appl->getUserStateFromRequest( $option.$view.'filter_view', 'filter_view', 'categories', 'cmd' );
		if( 'categories' != $filter_view )
		{
			$appl->setUserState( $option.$view.'filter_view', 'categories' );
			$appl->setUserState( $option.$view.'filter_order', '`ordering`' );
			$appl->setUserState( $option.$view.'filter_order_Dir', 'ASC' );
		}
		// get filter order
		$filter_order     = $appl->getUserStateFromRequest( $option.$view.'filter_order', 'filter_order', '`ordering`', 'cmd' );
		$filter_order_Dir = $appl->getUserStateFromRequest( $option.$view.'filter_order_Dir', 'filter_order_Dir', '', 'word' );
		// added check for order
		if( !in_array( $filter_order, array( 'ordering', 'name', 'published', 'id' ) ) )
		{
			$filter_order = 'ordering';
		}
		// set in state
		$this->setState( 'order', $filter_order );
		$this->setState( 'order_Dir', $filter_order_Dir );
	}

	function _buildContentOrderBy()
	{
		$orderby = ' ORDER BY '.$this->getState('order').' '.$this->getState('order_Dir').' ';
		return $orderby;
	}

	/**
	 * builds query
	 * @return string
	 *
	 */
	function _buildQuery()
	{
		// initialize
		$orderby = '';
		$orderby = $this->_buildContentOrderBy();
		// build final query
		$query = 'SELECT '
		       . '* '
		       . 'FROM `#__jmylife_categories` '
		       . $orderby
		       ;
		// all done!
		return $query;
	}


	/**
	 * builds item query
	 * @return string
	 *
	 */
	function _buildItemQuery()
	{
		// initialize
		$cid = JRequest::getInt('cid');
		// build final query
		return "SELECT * FROM `#__jmylife_categories` WHERE `id` = {$cid} ORDER BY `ordering`, `name`";
	}

	/**
	 * Gets the list data
	 * @return stdClass object of listings
	 *
	 * @todo use Joomla Tables instead of simple queries
	 */
	function getData()
	{
		// if data hasn't already been obtained, load it
		if( empty( $this->_data ) )
		{
			$query = $this->_buildQuery();
			$this->_data = $this->_getList( $query, $this->getState( 'limitstart' ), $this->getState( 'limit' ) );
		}
		return $this->_data;
	}

	/**
	 * Gets the item data
	 * @return stdClass object of listings
	 *
	 * @todo use Joomla Tables instead of simple queries
	 */
	function getItem()
	{
		// if data hasn't already been obtained, load it
		if( empty( $this->_data ) )
		{
			$query = $this->_buildItemQuery();
			$this->_data = $this->_getList( $query, $this->getState( 'limitstart' ), $this->getState( 'limit' ) );
		}
		return $this->_data;
	}

	/**
	 * Gets the total amount of listings
	 * @return int
	 */
	function getTotal()
	{
		// Load the content if it doesn't already exist
		if( empty( $this->_total ) )
		{
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount( $query );
		}
		return $this->_total;
	}

	/**
	 * Gets the listings pagination
	 * @return JPagination object
	 */
	function getPagination()
	{
		// Load the content if it doesn't already exist
		if( empty( $this->_pagination ) )
		{
			jimport( 'joomla.html.pagination' );
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState( 'limitstart' ), $this->getState( 'limit' ) );
		}
		return $this->_pagination;
	}
}