<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * components/com_jmylife/views/list/view.feed.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 * @since      1.0.8
 */
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
// imports
jimport( 'joomla.application.component.view' );

/**
 * Feed View class for the JMyLife Component
 *
 * @package    JMyLife
 */

class JmylifeViewList extends JView
{
	function display( $tpl = null )
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();

		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		JLoader::import('components.com_jmylife.helpers.itemid', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		$itemid = JmylifeItemidHelper::getInstance();

		// parameters
		$appl     =& JFactory::getApplication();
		$document =& JFactory::getDocument();
		$params   =& $appl->getParams();
		$feedEmail = ( @$appl->getCfg( 'feed_email' ) ) ? $appl->getCfg( 'feed_email' ) : 'author';
		$siteEmail = $appl->getCfg( 'mailfrom' );
		$catid     = JRequest::getInt( 'catid', 0 );
		$doctitle  = $_JMLConfig->get( 'jmylife_name' );
		$docdesc   = $_JMLConfig->get( 'jmylife_desc' );
		if (0 < $catid) {
			$_JMLConfig->db->setQuery( 'SELECT `name`, `description` FROM `#__jmylife_categories` WHERE id = '.$catid );
			if( $data = $_JMLConfig->db->loadRow() )
			{
				$doctitle = $data[0];
				if( strlen( $data[1] ) > 0 )
					$docdesc = $data[1];
			}
		}
		$document->setTitle( $doctitle );
		$document->setDescription( $docdesc );
		$document->setLink( JRoute::_( 'index.php?option=com_jmylife&view=list&Itemid='.$itemid->category( $catid ) ) );

		// Get some data from the model
		JRequest::setVar( 'limit', $appl->getCfg( 'feed_limit' ) );
		$rows =& $this->get( 'Data' );
		if (count($rows)) {
			foreach ($rows as $row) {
				// handle title
				$title = JText::sprintf('COM_JMYLIFE_STORY_TITLE', $row->user_alias);
				if ($_JMLConfig->getInt('allow_titles') && strlen($row->title)) {
					$title = $row->title;
				}
				// strip crap out of the title ;)
				$title = $html->unclean($title);
				$title = htmlspecialchars($title);

				// url link to article
				$link = htmlspecialchars($row->storylink);

				// strip html from feed item description text
				$description	= $row->fulltext;
				$description	= $html->unclean($description);
				$description	= $html->strip($description, true);
				$description	= htmlspecialchars($description);
				$description	= nl2br($description);
				$author			  = $row->user_alias;

				// load individual item creator class
				$item = new JFeedItem();
				$item->title = $title;
				$item->link = $link;
				$item->description = $description;
				$item->date = $row->time;
				$item->category = $row->catname;
				$item->author = $author;
				// loads item info into rss array
				$document->addItem($item);
			}
		}
	}
}